#include <assert.h>
#include "zend_API.h"
#include "zval_pool.h"


// NOTE: thread-unsafe

#define ZVAL_POOL_MIN_SIZE 10

static zval *pool = 0;
	
static void do_init();

int zval_pool_init(size_t size)
{
	if (size < ZVAL_POOL_MIN_SIZE)
		size = ZVAL_POOL_MIN_SIZE;
	pool = (zval *) malloc(sizeof(zval) * size);
	do_init();
}

void zval_pool_fini()
{
	// process gone!
}

zval * zval_pool_get(size_t index)
{
	return pool + index;
}

#define POOL_ZVAL_STRING(x, s) INIT_PZVAL((pool + x)); \
	ZVAL_STRING((pool + x), (s), 1)

// fill in rubbish here
static void do_init()
{
	INIT_PZVAL((pool + ZVAL_POOL_NULL));
	ZVAL_NULL((pool + ZVAL_POOL_NULL));
	POOL_ZVAL_STRING(ZVAL_POOL_NULL_FILTER, "null_filter");
	POOL_ZVAL_STRING(ZVAL_POOL_ECHO_FILTER, "echo_filter");
	POOL_ZVAL_STRING(ZVAL_POOL_OUTPUT, "__output");
	POOL_ZVAL_STRING(ZVAL_POOL_POLICY_EVAL, "__policy_eval");
}
