
dnl
dnl PHP_PROG_LEMON
dnl
dnl Search for lemon binary and check its version
dnl
AC_DEFUN([PHP_PROG_LEMON_REQ],[
  # we only support certain lemon versions
  lemon_version_list="1.0"

  AC_CHECK_PROG(LEMON, lemon, lemon)
  if test "$LEMON"; then
    AC_CACHE_CHECK([for lemon version], php_cv_lemon_version, [
      lemon_version=`$LEMON -x 2>/dev/null | $SED -e 's/^.* //'`
      php_cv_lemon_version=invalid
      for lemon_check_version in $lemon_version_list; do
        if test "$lemon_version" = "$lemon_check_version"; then
          php_cv_lemon_version="$lemon_check_version (ok)"
        fi
      done
    ])
  else
    lemon_version=none
  fi
  case $php_cv_lemon_version in
    ""|invalid[)]
      lemon_msg="Taint extension requires the lemon parser generator"
      AC_MSG_ERROR([$lemon_msg])
      LEMON="exit 0;"
      ;;
  esac
  PHP_SUBST(LEMON)
])


dnl
dnl PHP_PROG_RE2C
dnl
dnl Search for the re2c binary and check the version
dnl
AC_DEFUN([PHP_PROG_RE2C_REQ],[
  AC_CHECK_PROG(RE2C, re2c, re2c)
  if test -n "$RE2C"; then
    AC_CACHE_CHECK([for re2c version], php_cv_re2c_version, [
      re2c_vernum=`re2c --vernum 2>/dev/null`
      if test -z "$re2c_vernum" || test "$re2c_vernum" -lt "1200"; then
        php_cv_re2c_version=invalid
      else
        php_cv_re2c_version="`re2c --version | cut -d ' ' -f 2  2>/dev/null` (ok)"
      fi 
    ])
  fi
  case $php_cv_re2c_version in
    ""|invalid[)]
      AC_MSG_ERROR([Taint extension requires the re2c tokenizer generator.  You will need re2c 0.12.0 or later if you want to regenerate PHP parsers.])
      ;;
  esac
  PHP_SUBST(RE2C)
])

PHP_ARG_ENABLE(taint,
	[Whether to enable the "taint" extension],
	[ --enable-taint	Enable "taint" extension support])

if test $PHP_TAINT != "no"; then
        PHP_PROG_LEMON_REQ
        PHP_PROG_RE2C_REQ

dnl   Disable all old taint stuff.
dnl        AC_DEFINE(HAVE_TAINT, 1, [Whether you have "taint" support])
	PHP_NEW_EXTENSION(taint, taint.c pdo_user_sql_tokenizer.c pdo_user_sql_parser.c pdo_user_statement.c pdo_user.c, $ext-shared)
        PHP_ADD_MAKEFILE_FRAGMENT
fi
