--TEST--
TAINT clone policy when copying zvals
--SKIPIF--
<?php if (!extension_loaded('taint')) die('skip no taint support'); ?>
--FILE--
<?php

class Policy
{
  public $s = "policy1";
  function __toString () {return $this->s;}
  function __output() {}
}

function print_it ($a, $b, $c) {
  echo $a; echo "\n";
  echo $b; echo "\n";
  echo $c; echo "\n";
  echo taint_get_policy ($a); echo "\n";
  echo taint_get_policy ($b); echo "\n";
  echo taint_get_policy ($c); echo "\n";
}

$p1 = new Policy ();
$p1->s = "policy1";

$a = 1;
taint_set_policy ($a, $p1);
$b = $a;
$c = &$a;
print_it ($a, $b, $c);

// change b
$b = 10;
print_it ($a, $b, $c);

// change c's policy
taint_get_policy ($c)->s = "policy2";
print_it ($a, $b, $c);

//---------------------
echo "---\n";
$p1 = new Policy ();
$p1->s = "policy3";

$a = "a";
taint_set_policy ($a, $p1);
$b = $a;
$c = &$a;
print_it ($a, $b, $c);

// change b
$b = "b";
print_it ($a, $b, $c);

// change c's policy
taint_get_policy ($c)->s = "policy4";
print_it ($a, $b, $c);


?>
--EXPECT--
1
1
1
policy1
policy1
policy1
1
10
1
policy1

policy1
1
10
1
policy2

policy2
---
a
a
a
policy3
policy3
policy3
a
b
a
policy3

policy3
a
b
a
policy4

policy4
