--TEST--
TAINT for/each loop test
--SKIPIF--
<?php if (!extension_loaded('taint')) die('skip no taint support'); ?>
--INI--
--COOKIE--
--FILE--
<?php

echo "=== dump array y\n";
$y = array ("foo", "bar");
taint($y[0], 0x11);
taint($y[1], 0x22);
debug_zval_dump($y);

echo "=== x = each(y)\n";
while($x = each($y)) {
	echo "=== dump x\n";
	debug_zval_dump($x);
}

echo "=== foreach(y as x)\n";
foreach($y as $x) {
	echo "=== dump x\n";
	debug_zval_dump($x);
}

echo "=== foreach(y as k => v)\n";
foreach($y as $k => $v) {
	echo "=== dump k, v\n";
	debug_zval_dump($k);
	debug_zval_dump($v);
}

?>
--EXPECT--
=== dump array y
array(2) refcount(2){
  [0]=>
  string(3) "foo" refcount(1) taint(0x11)
  [1]=>
  string(3) "bar" refcount(1) taint(0x22)
}
=== x = each(y)
=== dump x
array(4) refcount(2){
  [1]=>
  string(3) "foo" refcount(3) taint(0x11)
  ["value"]=>
  string(3) "foo" refcount(3) taint(0x11)
  [0]=>
  long(0) refcount(2)
  ["key"]=>
  long(0) refcount(2)
}
=== dump x
array(4) refcount(2){
  [1]=>
  string(3) "bar" refcount(3) taint(0x22)
  ["value"]=>
  string(3) "bar" refcount(3) taint(0x22)
  [0]=>
  long(1) refcount(2)
  ["key"]=>
  long(1) refcount(2)
}
=== foreach(y as x)
=== dump x
string(3) "foo" refcount(3) taint(0x11)
=== dump x
string(3) "bar" refcount(3) taint(0x22)
=== foreach(y as k => v)
=== dump k, v
long(0) refcount(2)
string(3) "foo" refcount(3) taint(0x11)
=== dump k, v
long(1) refcount(2)
string(3) "bar" refcount(4) taint(0x22)
