--TEST--
TAINT func_get_arg(), func_get_args()
--SKIPIF--
<?php if (!extension_loaded('taint')) die('skip no taint support'); ?>
--INI--
--COOKIE--
--FILE--
<?php

function test_func_get_arg()
{
	for ($n = 0; $n < func_num_args(); $n++) {
		debug_zval_dump(func_get_arg($n));
	}
}

function test_func_get_args()
{
	debug_zval_dump(func_get_args());
}

echo "=== dump x y\n";
$x = "foo"; taint($x, 0x11);
$y = "bar"; taint($y, 0x22);
$z = "baz"; taint($z, 0x33);
debug_zval_dump($x);
debug_zval_dump($y);
debug_zval_dump($z);

echo "=== test func_get_arg(x)\n";
test_func_get_arg($x);

echo "=== test func_get_arg(x, y, z)\n";
test_func_get_arg($x, $y, $z);

echo "=== test func_get_args(x)\n";
test_func_get_args($x);

echo "=== test func_get_args(x, y, z)\n";
test_func_get_args($x, $y, $z);

?>
--EXPECT--
=== dump x y
string(3) "foo" refcount(2) taint(0x11)
string(3) "bar" refcount(2) taint(0x22)
string(3) "baz" refcount(2) taint(0x33)
=== test func_get_arg(x)
string(3) "foo" refcount(1) taint(0x11)
=== test func_get_arg(x, y, z)
string(3) "foo" refcount(1) taint(0x11)
string(3) "bar" refcount(1) taint(0x22)
string(3) "baz" refcount(1) taint(0x33)
=== test func_get_args(x)
array(1) refcount(1){
  [0]=>
  string(3) "foo" refcount(1) taint(0x11)
}
=== test func_get_args(x, y, z)
array(3) refcount(1){
  [0]=>
  string(3) "foo" refcount(1) taint(0x11)
  [1]=>
  string(3) "bar" refcount(1) taint(0x22)
  [2]=>
  string(3) "baz" refcount(1) taint(0x33)
}
