--TEST--
TAINT html escape test
--SKIPIF--
<?php if (!extension_loaded('taint')) die('skip no taint support'); ?>
--INI--
--FILE--
<?php
# Workaround to avoid absolute script pathnames in error messages.
include "taint_tests_error_handler.php";

# Untainted data test.

echo "======== 1: expect taint 0x0\n";
$x = "123";
debug_zval_dump($x);
echo "$x\n";

# Tainted data test.

echo "======== 2: expect taint 0xff\n";
taint($x, 0xff);
debug_zval_dump($x);
echo "$x\n";

# Sanitizer test.

echo "======== 3: htmlentities: expect taint 0xfd\n";
$y = $x;
$y = htmlentities($y);
debug_zval_dump($y);
echo "$y\n";

echo "======== 4: htmlspecialchars: expect taint 0xfd\n";
$y = $x;
$y = htmlspecialchars($y);
debug_zval_dump($y);
echo "$y\n";

?>
--EXPECT--
======== 1: expect taint 0x0
string(3) "123" refcount(2)
123
======== 2: expect taint 0xff
string(3) "123" refcount(2) taint(0xff)
Warning: echo(): Argument contains data that is not converted with htmlspecialchars() or htmlentities() in ext/taint/tests/html-escape.php on line 17
123
======== 3: htmlentities: expect taint 0xfd
string(3) "123" refcount(2) taint(0xfd)
123
======== 4: htmlspecialchars: expect taint 0xfd
string(3) "123" refcount(2) taint(0xfd)
123
