--TEST--
TAINT mysql command escape test
--SKIPIF--
<?php
if (!extension_loaded('taint')) die('skip no taint support');
if (!extension_loaded('mysql')) die('skip no mysql support');
if (!file_exists("/tmp/mysql.sock")) die('skip no mysql server');
?>
--INI--
taint_marks_other = TC_NONE
--FILE--
<?php
# Workaround to avoid absolute script pathnames in error messages.
include "taint_tests_error_handler.php";

# Untainted data test.

echo "======= 1: expect taint 0x0\n";
$x = "123";
debug_zval_dump($x);
system("echo $x");

# Tainted data test.

echo "======= 2: expect taint 0xff\n";
taint($x, 0xff);
debug_zval_dump($x);

# Sanitizer test.

echo "======= 3: mysql_escape_string: expect taint 0xf7\n";
$y = $x;
$y = mysql_escape_string($y);
debug_zval_dump($y);

echo "======= 4: mysql_real_escape_string: expect taint 0xf7\n";
$y = $x;
$y = mysql_real_escape_string($y);
debug_zval_dump($y);

?>
--EXPECT--
======= 1: expect taint 0x0
string(3) "123" refcount(2)
123
======= 2: expect taint 0xff
string(3) "123" refcount(2) taint(0xff)
======= 3: mysql_escape_string: expect taint 0xf7
string(3) "123" refcount(2) taint(0xf7)
======= 4: mysql_real_escape_string: expect taint 0xf7
string(3) "123" refcount(2) taint(0xf7)
