--TEST--
TAINT mysqli command escape test
--SKIPIF--
<?php if (!extension_loaded('taint')) die('skip no taint support'); ?>
<?php if (!extension_loaded('mysqli')) die('skip no mysqli support'); ?>
--INI--
taint_marks_other = TC_NONE
--FILE--
<?php
# Workaround to avoid absolute script pathnames in error messages.
include "taint_tests_error_handler.php";

# Untainted data test.

echo "======= 1: expect taint 0x0\n";
$x = "123";
debug_zval_dump($x);

# Tainted data test.

echo "======= 2: expect taint 0xff\n";
taint($x, 0xff);
debug_zval_dump($x);

# Sanitizer test.

echo "======= 3: mysqli_real_escape_string: expect taint 0xfb\n";
$y = $x;
$y = escapeshellarg($y);
debug_zval_dump($y);

?>
--EXPECT--
======= 1: expect taint 0x0
string(3) "123" refcount(2)
======= 2: expect taint 0xff
string(3) "123" refcount(2) taint(0xff)
======= 3: mysqli_real_escape_string: expect taint 0xfb
string(5) "'123'" refcount(2) taint(0xfb)
