--TEST--
TAINT parse_str
--SKIPIF--
<?php if (!extension_loaded('taint')) die('skip no taint support'); ?>
--INI--
--FILE--
<?php

# Workaround to avoid absolute script pathnames in error messages.
include "taint_tests_error_handler.php";

echo "taint_error_level = ", ini_get("taint_error_level"), "\n";

$foo = "aap=noot&foo=bar";
taint($foo, 127);
debug_zval_dump($foo);
echo "\$foo=\"$foo\"\n";

parse_str($foo, $ar);
debug_zval_dump($ar);

parse_str($foo);
echo "\$aap=\"$aap\", \$foo=\"$foo\"\n";

?>
--EXPECT--
taint_error_level = 512
string(16) "aap=noot&foo=bar" refcount(2) taint(0x7f)
Warning: echo(): Argument contains data that is not converted with htmlspecialchars() or htmlentities() in ext/taint/tests/parse_str.php on line 11
$foo="aap=noot&foo=bar"
array(2) refcount(2){
  ["aap"]=>
  string(4) "noot" refcount(1) taint(0x7f)
  ["foo"]=>
  string(3) "bar" refcount(1) taint(0x7f)
}
Warning: parse_str(): Argument 1 contains data that is not marked safe for internal control (TC_SELF) in ext/taint/tests/parse_str.php on line 16
Warning: echo(): Argument contains data that is not converted with htmlspecialchars() or htmlentities() in ext/taint/tests/parse_str.php on line 17
$aap="noot", $foo="bar"
