--TEST--
TAINT preg_grep
--SKIPIF--
<?php if (!extension_loaded('pcre')) die('skip no pcre support'); ?>
<?php if (!extension_loaded('taint')) die('skip no taint support'); ?>
--FILE--
<?php
# Workaround to avoid absolute script pathnames in error messages.
include "taint_tests_error_handler.php";

echo "==== pattern and tainted_pattern\n";
$tainted_pattern = $pattern = "/(\d+)/";
taint($tainted_pattern, TC_ALL);
debug_zval_dump($pattern);
debug_zval_dump($tainted_pattern);

echo "==== subjects and tainted_subjects11_33\n";
$tainted_subjects11_33 = $subjects = array("1 2 3 4 5 6", "a b c d e f", "9 8 7 6 5 4");
taint($tainted_subjects11_33[0], 0x11);
taint($tainted_subjects11_33[1], 0x22);
taint($tainted_subjects11_33[2], 0x33);
debug_zval_dump($subjects);
debug_zval_dump($tainted_subjects11_33);

echo "==== flags and tainted_flags\n";
$tainted_flags = $flags = PREG_GREP_INVERT;
taint($tainted_flags, TC_ALL);
debug_zval_dump($flags);
debug_zval_dump($tainted_flags);

echo "==== preg_grep(pattern, subjects)\n";
$result = preg_grep($pattern, $subjects);
debug_zval_dump($result);

echo "==== preg_grep(tainted_pattern, subjects)\n";
$result = preg_grep($tainted_pattern, $subjects);
debug_zval_dump($result);

echo "==== preg_grep(pattern, tainted_subjects11_33)\n";
$result = preg_grep($pattern, $tainted_subjects11_33);
debug_zval_dump($result);

echo "==== preg_grep(pattern, subjects, flags)\n";
$result = preg_grep($pattern, $subjects, $flags);
debug_zval_dump($result);

echo "==== preg_grep(pattern, tainted_subjects11_33, flags)\n";
$result = preg_grep($pattern, $tainted_subjects11_33, $flags);
debug_zval_dump($result);

echo "==== preg_grep(pattern, subjects, tainted_flags)\n";
$result = preg_grep($pattern, $subjects, $tainted_flags);
debug_zval_dump($result);

?>

--EXPECT--
==== pattern and tainted_pattern
string(7) "/(\d+)/" refcount(2)
string(7) "/(\d+)/" refcount(2) taint(0xff)
==== subjects and tainted_subjects11_33
array(3) refcount(2){
  [0]=>
  string(11) "1 2 3 4 5 6" refcount(1)
  [1]=>
  string(11) "a b c d e f" refcount(1)
  [2]=>
  string(11) "9 8 7 6 5 4" refcount(1)
}
array(3) refcount(2){
  [0]=>
  string(11) "1 2 3 4 5 6" refcount(1) taint(0x11)
  [1]=>
  string(11) "a b c d e f" refcount(1) taint(0x22)
  [2]=>
  string(11) "9 8 7 6 5 4" refcount(1) taint(0x33)
}
==== flags and tainted_flags
long(1) refcount(2)
long(1) refcount(2) taint(0xff)
==== preg_grep(pattern, subjects)
array(2) refcount(2){
  [0]=>
  string(11) "1 2 3 4 5 6" refcount(2)
  [2]=>
  string(11) "9 8 7 6 5 4" refcount(2)
}
==== preg_grep(tainted_pattern, subjects)
Warning: preg_grep(): Argument 1 contains data that is not marked safe for internal control (TC_SELF) in ext/taint/tests/preg_grep.php on line 30
array(2) refcount(2){
  [0]=>
  string(11) "1 2 3 4 5 6" refcount(2)
  [2]=>
  string(11) "9 8 7 6 5 4" refcount(2)
}
==== preg_grep(pattern, tainted_subjects11_33)
array(2) refcount(2){
  [0]=>
  string(11) "1 2 3 4 5 6" refcount(2) taint(0x11)
  [2]=>
  string(11) "9 8 7 6 5 4" refcount(2) taint(0x33)
}
==== preg_grep(pattern, subjects, flags)
array(1) refcount(2){
  [1]=>
  string(11) "a b c d e f" refcount(2)
}
==== preg_grep(pattern, tainted_subjects11_33, flags)
array(1) refcount(2){
  [1]=>
  string(11) "a b c d e f" refcount(2) taint(0x22)
}
==== preg_grep(pattern, subjects, tainted_flags)
Warning: preg_grep(): Argument 3 contains data that is not marked safe for internal control (TC_SELF) in ext/taint/tests/preg_grep.php on line 46
array(1) refcount(2){
  [1]=>
  string(11) "a b c d e f" refcount(2)
}
