--TEST--
TAINT preg_match, preg_match_all
--SKIPIF--
<?php if (!extension_loaded('pcre')) die('skip no pcre support'); ?>
<?php if (!extension_loaded('taint')) die('skip no taint support'); ?>
--FILE--
<?php
# Workaround to avoid absolute script pathnames in error messages.
include "taint_tests_error_handler.php";

$subject = "1 2 3 4 5 6";
taint($subject,0x55);

echo "==== 1 preg_match(pattern, subject)\n";
$match_count = preg_match("/(\d+)\s*(\d+)/", $subject);
debug_zval_dump($match_count);

echo "==== 2 preg_match(pattern, subject, matches)\n";
$match_count = preg_match("/(\d+)\s*(\d+)/", $subject, $matches);
debug_zval_dump($match_count);
debug_zval_dump($matches);

echo "==== 3 preg_match(pattern, subject, matches, PREG_OFFSET_CAPTURE)\n";
$match_count = preg_match("/(\d+)\s*(\d+)/", $subject, $matches, PREG_OFFSET_CAPTURE);
debug_zval_dump($match_count);
debug_zval_dump($matches);

echo "==== 4 preg_match_all(pattern, subject, matches)\n";
$match_count = preg_match_all("/(\d+)\s*(\d+)/", $subject, $matches);
debug_zval_dump($match_count);
debug_zval_dump($matches);

echo "==== 5 preg_match_all(pattern, subject, matches, PREG_SET_ORDER)\n";
$match_count = preg_match_all("/(\d+)\s*(\d+)/", $subject, $matches, PREG_SET_ORDER);
debug_zval_dump($match_count);
debug_zval_dump($matches);

echo "==== 6 preg_match_all(pattern, subject, matches, PREG_PATTERN_ORDER | PREG_OFFSET_CAPTURE)\n";
$match_count = preg_match_all("/(\d+)\s*(\d+)/", $subject, $matches, PREG_PATTERN_ORDER | PREG_OFFSET_CAPTURE);
debug_zval_dump($match_count);
debug_zval_dump($matches);

echo "==== 7 preg_match_all(pattern, subject, matches, PREG_OFFSET_CAPTURE)\n";
$match_count = preg_match_all("/(\d+)\s*(\d+)/", $subject, $matches, PREG_OFFSET_CAPTURE);
debug_zval_dump($match_count);
debug_zval_dump($matches);

echo "==== 8 preg_match_all(pattern, subject, matches, PREG_SET_ORDER | PREG_OFFSET_CAPTURE)\n";
$match_count = preg_match_all("/(\d+)\s*(\d+)/", $subject, $matches, PREG_SET_ORDER | PREG_OFFSET_CAPTURE);
debug_zval_dump($match_count);
debug_zval_dump($matches);

echo "==== 9 preg_match_all(pattern, subject, matches, PREG_PATTERN_ORDER | PREG_OFFSET_CAPTURE)\n";
$match_count = preg_match_all("/(\d+)\s*(\d+)/", $subject, $matches, PREG_PATTERN_ORDER | PREG_OFFSET_CAPTURE);
debug_zval_dump($match_count);
debug_zval_dump($matches);

echo "==== 10 preg_match(taintedpattern, subject)\n";
$taintedpattern = "/(\d+)\s*(\d+)/";
taint($taintedpattern, TC_ALL);
$match_count = preg_match($taintedpattern, $subject);
debug_zval_dump($match_count);

echo "==== 4 preg_match_all(taintedpattern, subject, matches)\n";
$match_count = preg_match_all($taintedpattern, $subject, $matches);
debug_zval_dump($match_count);
debug_zval_dump($matches);

?>
--EXPECT--
==== 1 preg_match(pattern, subject)
long(1) refcount(2)
==== 2 preg_match(pattern, subject, matches)
long(1) refcount(2)
array(3) refcount(2){
  [0]=>
  string(3) "1 2" refcount(1) taint(0x55)
  [1]=>
  string(1) "1" refcount(1) taint(0x55)
  [2]=>
  string(1) "2" refcount(1) taint(0x55)
}
==== 3 preg_match(pattern, subject, matches, PREG_OFFSET_CAPTURE)
long(1) refcount(2)
array(3) refcount(2){
  [0]=>
  array(2) refcount(1){
    [0]=>
    string(3) "1 2" refcount(1) taint(0x55)
    [1]=>
    long(0) refcount(1)
  }
  [1]=>
  array(2) refcount(1){
    [0]=>
    string(1) "1" refcount(1) taint(0x55)
    [1]=>
    long(0) refcount(1)
  }
  [2]=>
  array(2) refcount(1){
    [0]=>
    string(1) "2" refcount(1) taint(0x55)
    [1]=>
    long(2) refcount(1)
  }
}
==== 4 preg_match_all(pattern, subject, matches)
long(3) refcount(2)
array(3) refcount(2){
  [0]=>
  array(3) refcount(1){
    [0]=>
    string(3) "1 2" refcount(1) taint(0x55)
    [1]=>
    string(3) "3 4" refcount(1) taint(0x55)
    [2]=>
    string(3) "5 6" refcount(1) taint(0x55)
  }
  [1]=>
  array(3) refcount(1){
    [0]=>
    string(1) "1" refcount(1) taint(0x55)
    [1]=>
    string(1) "3" refcount(1) taint(0x55)
    [2]=>
    string(1) "5" refcount(1) taint(0x55)
  }
  [2]=>
  array(3) refcount(1){
    [0]=>
    string(1) "2" refcount(1) taint(0x55)
    [1]=>
    string(1) "4" refcount(1) taint(0x55)
    [2]=>
    string(1) "6" refcount(1) taint(0x55)
  }
}
==== 5 preg_match_all(pattern, subject, matches, PREG_SET_ORDER)
long(3) refcount(2)
array(3) refcount(2){
  [0]=>
  array(3) refcount(1){
    [0]=>
    string(3) "1 2" refcount(1) taint(0x55)
    [1]=>
    string(1) "1" refcount(1) taint(0x55)
    [2]=>
    string(1) "2" refcount(1) taint(0x55)
  }
  [1]=>
  array(3) refcount(1){
    [0]=>
    string(3) "3 4" refcount(1) taint(0x55)
    [1]=>
    string(1) "3" refcount(1) taint(0x55)
    [2]=>
    string(1) "4" refcount(1) taint(0x55)
  }
  [2]=>
  array(3) refcount(1){
    [0]=>
    string(3) "5 6" refcount(1) taint(0x55)
    [1]=>
    string(1) "5" refcount(1) taint(0x55)
    [2]=>
    string(1) "6" refcount(1) taint(0x55)
  }
}
==== 6 preg_match_all(pattern, subject, matches, PREG_PATTERN_ORDER | PREG_OFFSET_CAPTURE)
long(3) refcount(2)
array(3) refcount(2){
  [0]=>
  array(3) refcount(1){
    [0]=>
    array(2) refcount(1){
      [0]=>
      string(3) "1 2" refcount(1) taint(0x55)
      [1]=>
      long(0) refcount(1)
    }
    [1]=>
    array(2) refcount(1){
      [0]=>
      string(3) "3 4" refcount(1) taint(0x55)
      [1]=>
      long(4) refcount(1)
    }
    [2]=>
    array(2) refcount(1){
      [0]=>
      string(3) "5 6" refcount(1) taint(0x55)
      [1]=>
      long(8) refcount(1)
    }
  }
  [1]=>
  array(3) refcount(1){
    [0]=>
    array(2) refcount(1){
      [0]=>
      string(1) "1" refcount(1) taint(0x55)
      [1]=>
      long(0) refcount(1)
    }
    [1]=>
    array(2) refcount(1){
      [0]=>
      string(1) "3" refcount(1) taint(0x55)
      [1]=>
      long(4) refcount(1)
    }
    [2]=>
    array(2) refcount(1){
      [0]=>
      string(1) "5" refcount(1) taint(0x55)
      [1]=>
      long(8) refcount(1)
    }
  }
  [2]=>
  array(3) refcount(1){
    [0]=>
    array(2) refcount(1){
      [0]=>
      string(1) "2" refcount(1) taint(0x55)
      [1]=>
      long(2) refcount(1)
    }
    [1]=>
    array(2) refcount(1){
      [0]=>
      string(1) "4" refcount(1) taint(0x55)
      [1]=>
      long(6) refcount(1)
    }
    [2]=>
    array(2) refcount(1){
      [0]=>
      string(1) "6" refcount(1) taint(0x55)
      [1]=>
      long(10) refcount(1)
    }
  }
}
==== 7 preg_match_all(pattern, subject, matches, PREG_OFFSET_CAPTURE)
long(3) refcount(2)
array(3) refcount(2){
  [0]=>
  array(3) refcount(1){
    [0]=>
    array(2) refcount(1){
      [0]=>
      string(3) "1 2" refcount(1) taint(0x55)
      [1]=>
      long(0) refcount(1)
    }
    [1]=>
    array(2) refcount(1){
      [0]=>
      string(3) "3 4" refcount(1) taint(0x55)
      [1]=>
      long(4) refcount(1)
    }
    [2]=>
    array(2) refcount(1){
      [0]=>
      string(3) "5 6" refcount(1) taint(0x55)
      [1]=>
      long(8) refcount(1)
    }
  }
  [1]=>
  array(3) refcount(1){
    [0]=>
    array(2) refcount(1){
      [0]=>
      string(1) "1" refcount(1) taint(0x55)
      [1]=>
      long(0) refcount(1)
    }
    [1]=>
    array(2) refcount(1){
      [0]=>
      string(1) "3" refcount(1) taint(0x55)
      [1]=>
      long(4) refcount(1)
    }
    [2]=>
    array(2) refcount(1){
      [0]=>
      string(1) "5" refcount(1) taint(0x55)
      [1]=>
      long(8) refcount(1)
    }
  }
  [2]=>
  array(3) refcount(1){
    [0]=>
    array(2) refcount(1){
      [0]=>
      string(1) "2" refcount(1) taint(0x55)
      [1]=>
      long(2) refcount(1)
    }
    [1]=>
    array(2) refcount(1){
      [0]=>
      string(1) "4" refcount(1) taint(0x55)
      [1]=>
      long(6) refcount(1)
    }
    [2]=>
    array(2) refcount(1){
      [0]=>
      string(1) "6" refcount(1) taint(0x55)
      [1]=>
      long(10) refcount(1)
    }
  }
}
==== 8 preg_match_all(pattern, subject, matches, PREG_SET_ORDER | PREG_OFFSET_CAPTURE)
long(3) refcount(2)
array(3) refcount(2){
  [0]=>
  array(3) refcount(1){
    [0]=>
    array(2) refcount(1){
      [0]=>
      string(3) "1 2" refcount(1) taint(0x55)
      [1]=>
      long(0) refcount(1)
    }
    [1]=>
    array(2) refcount(1){
      [0]=>
      string(1) "1" refcount(1) taint(0x55)
      [1]=>
      long(0) refcount(1)
    }
    [2]=>
    array(2) refcount(1){
      [0]=>
      string(1) "2" refcount(1) taint(0x55)
      [1]=>
      long(2) refcount(1)
    }
  }
  [1]=>
  array(3) refcount(1){
    [0]=>
    array(2) refcount(1){
      [0]=>
      string(3) "3 4" refcount(1) taint(0x55)
      [1]=>
      long(4) refcount(1)
    }
    [1]=>
    array(2) refcount(1){
      [0]=>
      string(1) "3" refcount(1) taint(0x55)
      [1]=>
      long(4) refcount(1)
    }
    [2]=>
    array(2) refcount(1){
      [0]=>
      string(1) "4" refcount(1) taint(0x55)
      [1]=>
      long(6) refcount(1)
    }
  }
  [2]=>
  array(3) refcount(1){
    [0]=>
    array(2) refcount(1){
      [0]=>
      string(3) "5 6" refcount(1) taint(0x55)
      [1]=>
      long(8) refcount(1)
    }
    [1]=>
    array(2) refcount(1){
      [0]=>
      string(1) "5" refcount(1) taint(0x55)
      [1]=>
      long(8) refcount(1)
    }
    [2]=>
    array(2) refcount(1){
      [0]=>
      string(1) "6" refcount(1) taint(0x55)
      [1]=>
      long(10) refcount(1)
    }
  }
}
==== 9 preg_match_all(pattern, subject, matches, PREG_PATTERN_ORDER | PREG_OFFSET_CAPTURE)
long(3) refcount(2)
array(3) refcount(2){
  [0]=>
  array(3) refcount(1){
    [0]=>
    array(2) refcount(1){
      [0]=>
      string(3) "1 2" refcount(1) taint(0x55)
      [1]=>
      long(0) refcount(1)
    }
    [1]=>
    array(2) refcount(1){
      [0]=>
      string(3) "3 4" refcount(1) taint(0x55)
      [1]=>
      long(4) refcount(1)
    }
    [2]=>
    array(2) refcount(1){
      [0]=>
      string(3) "5 6" refcount(1) taint(0x55)
      [1]=>
      long(8) refcount(1)
    }
  }
  [1]=>
  array(3) refcount(1){
    [0]=>
    array(2) refcount(1){
      [0]=>
      string(1) "1" refcount(1) taint(0x55)
      [1]=>
      long(0) refcount(1)
    }
    [1]=>
    array(2) refcount(1){
      [0]=>
      string(1) "3" refcount(1) taint(0x55)
      [1]=>
      long(4) refcount(1)
    }
    [2]=>
    array(2) refcount(1){
      [0]=>
      string(1) "5" refcount(1) taint(0x55)
      [1]=>
      long(8) refcount(1)
    }
  }
  [2]=>
  array(3) refcount(1){
    [0]=>
    array(2) refcount(1){
      [0]=>
      string(1) "2" refcount(1) taint(0x55)
      [1]=>
      long(2) refcount(1)
    }
    [1]=>
    array(2) refcount(1){
      [0]=>
      string(1) "4" refcount(1) taint(0x55)
      [1]=>
      long(6) refcount(1)
    }
    [2]=>
    array(2) refcount(1){
      [0]=>
      string(1) "6" refcount(1) taint(0x55)
      [1]=>
      long(10) refcount(1)
    }
  }
}
==== 10 preg_match(taintedpattern, subject)
Warning: preg_match(): Argument 1 contains data that is not converted with preg_quote() in ext/taint/tests/preg_match.php on line 55
long(1) refcount(2)
==== 4 preg_match_all(taintedpattern, subject, matches)
Warning: preg_match_all(): Argument 1 contains data that is not converted with preg_quote() in ext/taint/tests/preg_match.php on line 59
long(3) refcount(2)
array(3) refcount(2){
  [0]=>
  array(3) refcount(1){
    [0]=>
    string(3) "1 2" refcount(1) taint(0x55)
    [1]=>
    string(3) "3 4" refcount(1) taint(0x55)
    [2]=>
    string(3) "5 6" refcount(1) taint(0x55)
  }
  [1]=>
  array(3) refcount(1){
    [0]=>
    string(1) "1" refcount(1) taint(0x55)
    [1]=>
    string(1) "3" refcount(1) taint(0x55)
    [2]=>
    string(1) "5" refcount(1) taint(0x55)
  }
  [2]=>
  array(3) refcount(1){
    [0]=>
    string(1) "2" refcount(1) taint(0x55)
    [1]=>
    string(1) "4" refcount(1) taint(0x55)
    [2]=>
    string(1) "6" refcount(1) taint(0x55)
  }
}
