--TEST--
TAINT preg_quote
--SKIPIF--
<?php if (!extension_loaded('pcre')) die('skip no pcre support'); ?>
<?php if (!extension_loaded('taint')) die('skip no taint support'); ?>
--FILE--
<?php
# Workaround to avoid absolute script pathnames in error messages.
include "taint_tests_error_handler.php";

echo "==== pattern and tainted_pattern\n";
$tainted_pattern = $pattern = "(\d+)/(\d+)";
taint($tainted_pattern, TC_ALL);
debug_zval_dump($pattern);
debug_zval_dump($tainted_pattern);

echo "==== delimiter and tainted_delimiter\n";
$tainted_delimiter = $delimiter = "/";
taint($tainted_delimiter, TC_ALL);
debug_zval_dump($delimiter);
debug_zval_dump($tainted_delimiter);

echo "==== preg_quote(pattern)\n";
$result = preg_quote($pattern);
debug_zval_dump($result);

echo "==== preg_quote(tainted_pattern)\n";
$result = preg_quote($tainted_pattern);
debug_zval_dump($result);

echo "==== preg_quote(pattern, delimiter)\n";
$result = preg_quote($pattern, $delimiter);
debug_zval_dump($result);

echo "==== preg_quote(pattern, tainted_delimiter)\n";
$result = preg_quote($pattern, $tainted_delimiter);
debug_zval_dump($result);

?>

--EXPECT--
==== pattern and tainted_pattern
string(11) "(\d+)/(\d+)" refcount(2)
string(11) "(\d+)/(\d+)" refcount(2) taint(0xff)
==== delimiter and tainted_delimiter
string(1) "/" refcount(2)
string(1) "/" refcount(2) taint(0xff)
==== preg_quote(pattern)
string(19) "\(\\d\+\)/\(\\d\+\)" refcount(2)
==== preg_quote(tainted_pattern)
string(19) "\(\\d\+\)/\(\\d\+\)" refcount(2) taint(0x7f)
==== preg_quote(pattern, delimiter)
string(20) "\(\\d\+\)\/\(\\d\+\)" refcount(2)
==== preg_quote(pattern, tainted_delimiter)
Warning: preg_quote(): Argument 2 contains data that is not marked safe for internal control (TC_SELF) in ext/taint/tests/preg_quote.php on line 30
string(20) "\(\\d\+\)\/\(\\d\+\)" refcount(2)
