--TEST--
TAINT preg_replace, preg_replace_callback
--SKIPIF--
<?php if (!extension_loaded('pcre')) die('skip no pcre support'); ?>
<?php if (!extension_loaded('taint')) die('skip no taint support'); ?>
--FILE--
<?php
# Workaround to avoid absolute script pathnames in error messages.
include "taint_tests_error_handler.php";

echo "==== pattern and taintedpattern\n";
$taintedpattern = $pattern = "/(\d+)/";
taint($taintedpattern, TC_ALL);
debug_zval_dump($pattern);
debug_zval_dump($taintedpattern);

echo "==== replacement and taintedreplacement55\n";
$taintedreplacement55 = $replacement = ">$1<";
taint($taintedreplacement55, 0x55);
debug_zval_dump($replacement);
debug_zval_dump($taintedreplacement55);

echo "==== subject and taintedsubject55\n";
$taintedsubject55 = $subject = "9 8 7 6 5 4";
taint($taintedsubject55,0x55);
debug_zval_dump($subject);
debug_zval_dump($taintedsubject55);

echo "==== limit and taintedlimit\n";
$taintedlimit = $limit = "9";
taint($taintedlimit, TC_ALL);
debug_zval_dump($limit);
debug_zval_dump($taintedlimit);

echo "==== patterns and taintedpatterns11_22\n";
$taintedpatterns11_22 = $patterns = array("/(\d+)/", "/(\s+)/");
taint($taintedpatterns11_22[0], 0x11 | TC_PCRE);
taint($taintedpatterns11_22[1], 0x22 | TC_PCRE);
debug_zval_dump($patterns);
debug_zval_dump($taintedpatterns11_22);

echo "==== replacements and taintedreplacements11_22\n";
$taintedreplacements11_22 = $replacements = array(">$1<", "($1)");
taint($taintedreplacements11_22[0], 0x11);
taint($taintedreplacements11_22[1], 0x22);
debug_zval_dump($replacements);
debug_zval_dump($taintedreplacements11_22);

echo "==== subjects and taintedsubjects11_22\n";
$taintedsubjects11_22 = $subjects = array("1 2 3 4 5 6", "9 8 7 6 5 4");
taint($taintedsubjects11_22[0], 0x11);
taint($taintedsubjects11_22[1], 0x22);
debug_zval_dump($subjects);
debug_zval_dump($taintedsubjects11_22);

echo "==== preg_replace(pattern, replacement, subject)\n";
$result = preg_replace($pattern, $replacement, $subject);
debug_zval_dump($result);

echo "==== preg_replace(taintedpattern, replacement, subject)\n";
$result = preg_replace($taintedpattern, $replacement, $subject);
debug_zval_dump($result);

echo "==== preg_replace(pattern, taintedreplacement55, subject)\n";
$result = preg_replace($pattern, $taintedreplacement55, $subject);
debug_zval_dump($result);

echo "==== preg_replace(pattern, replacement, taintedsubject55)\n";
$result = preg_replace($pattern, $replacement, $taintedsubject55);
debug_zval_dump($result);

echo "==== preg_replace(pattern, replacement, subject, limit)\n";
$result = preg_replace($pattern, $replacement, $subject, $limit);
debug_zval_dump($result);

echo "==== preg_replace(pattern, replacement, subject, taintedlimit)\n";
$result = preg_replace($pattern, $replacement, $subject, $taintedlimit);
debug_zval_dump($result);

echo "==== preg_replace(patterns[], replacement, taintedsubject55)\n";
$result = preg_replace($patterns, ">$1<", $taintedsubject55);
debug_zval_dump($result);

echo "==== preg_replace(taintedpatterns11_22[], replacement, subject)\n";
$result = preg_replace($taintedpatterns11_22, ">$1<", $subject);
debug_zval_dump($result);

echo "==== preg_replace(patterns[], replacements[], taintedsubject55)\n";
$result = preg_replace($patterns, $replacements, $taintedsubject55);
debug_zval_dump($result);

echo "==== preg_replace(patterns[], taintedreplacements11_22[], subject)\n";
$result = preg_replace($patterns, $taintedreplacements11_22, $subject);
debug_zval_dump($result);

echo "==== preg_replace(pattern/e, '>subject<', subject)\n";
$result = preg_replace($pattern . "e", '">$subject<"', $subject);
debug_zval_dump($result);

echo "==== preg_replace(pattern/e, '>subject<', taintedsubject55)\n";
$result = preg_replace($pattern . "e", '">$subject<"', $taintedsubject55);
debug_zval_dump($result);

echo "==== preg_replace(pattern/e, '>taintedsubject55<', subject)\n";
$result = preg_replace($pattern . "e", '">$taintedsubject55<"', $subject);
debug_zval_dump($result);

echo "==== preg_replace(pattern/e, >taintedsubject55<, subject)\n";
$result = preg_replace($pattern . "e", "'>$taintedsubject55<'", $subject);
debug_zval_dump($result);

function callback($frags) { return implode("#", $frags); }
$tainted_callback = $callback = "callback";
taint($tainted_callback, TC_ALL);

echo "==== preg_replace_callback(pattern, create_function, subject)\n";
$result = preg_replace_callback($pattern, create_function('$frags', 
					'return implode("#", $frags);'), $subject);
debug_zval_dump($result);

echo "==== preg_replace_callback(pattern, callback, subject)\n";
$result = preg_replace_callback($pattern, $callback, $subject);
debug_zval_dump($result);

echo "==== preg_replace_callback(pattern, callback, taintedsubject55)\n";
$result = preg_replace_callback($pattern, $callback, $taintedsubject55);
debug_zval_dump($result);

echo "==== preg_replace_callback(pattern, tainted_callback, subject)\n";
$result = preg_replace_callback($pattern, $tainted_callback, $subject);
debug_zval_dump($result);

?>
--EXPECT--
==== pattern and taintedpattern
string(7) "/(\d+)/" refcount(2)
string(7) "/(\d+)/" refcount(2) taint(0xff)
==== replacement and taintedreplacement55
string(4) ">$1<" refcount(2)
string(4) ">$1<" refcount(2) taint(0x55)
==== subject and taintedsubject55
string(11) "9 8 7 6 5 4" refcount(2)
string(11) "9 8 7 6 5 4" refcount(2) taint(0x55)
==== limit and taintedlimit
string(1) "9" refcount(2)
string(1) "9" refcount(2) taint(0xff)
==== patterns and taintedpatterns11_22
array(2) refcount(2){
  [0]=>
  string(7) "/(\d+)/" refcount(1)
  [1]=>
  string(7) "/(\s+)/" refcount(1)
}
array(2) refcount(2){
  [0]=>
  string(7) "/(\d+)/" refcount(1) taint(0x91)
  [1]=>
  string(7) "/(\s+)/" refcount(1) taint(0xa2)
}
==== replacements and taintedreplacements11_22
array(2) refcount(2){
  [0]=>
  string(4) ">$1<" refcount(1)
  [1]=>
  string(4) "($1)" refcount(1)
}
array(2) refcount(2){
  [0]=>
  string(4) ">$1<" refcount(1) taint(0x11)
  [1]=>
  string(4) "($1)" refcount(1) taint(0x22)
}
==== subjects and taintedsubjects11_22
array(2) refcount(2){
  [0]=>
  string(11) "1 2 3 4 5 6" refcount(1)
  [1]=>
  string(11) "9 8 7 6 5 4" refcount(1)
}
array(2) refcount(2){
  [0]=>
  string(11) "1 2 3 4 5 6" refcount(1) taint(0x11)
  [1]=>
  string(11) "9 8 7 6 5 4" refcount(1) taint(0x22)
}
==== preg_replace(pattern, replacement, subject)
string(23) ">9< >8< >7< >6< >5< >4<" refcount(2)
==== preg_replace(taintedpattern, replacement, subject)
Warning: preg_replace(): Regular expression contains data that is not converted with preg_quote() in ext/taint/tests/preg_replace.php on line 55
string(23) ">9< >8< >7< >6< >5< >4<" refcount(2)
==== preg_replace(pattern, taintedreplacement55, subject)
string(23) ">9< >8< >7< >6< >5< >4<" refcount(2) taint(0x55)
==== preg_replace(pattern, replacement, taintedsubject55)
string(23) ">9< >8< >7< >6< >5< >4<" refcount(2) taint(0x55)
==== preg_replace(pattern, replacement, subject, limit)
string(23) ">9< >8< >7< >6< >5< >4<" refcount(2)
==== preg_replace(pattern, replacement, subject, taintedlimit)
Warning: preg_replace(): Argument 4 contains data that is not marked safe for internal control (TC_SELF) in ext/taint/tests/preg_replace.php on line 71
string(23) ">9< >8< >7< >6< >5< >4<" refcount(2)
==== preg_replace(patterns[], replacement, taintedsubject55)
string(33) ">9<> <>8<> <>7<> <>6<> <>5<> <>4<" refcount(2) taint(0x55)
==== preg_replace(taintedpatterns11_22[], replacement, subject)
Warning: preg_replace(): Regular expression contains data that is not converted with preg_quote() in ext/taint/tests/preg_replace.php on line 79
Warning: preg_replace(): Regular expression contains data that is not converted with preg_quote() in ext/taint/tests/preg_replace.php on line 79
string(33) ">9<> <>8<> <>7<> <>6<> <>5<> <>4<" refcount(2)
==== preg_replace(patterns[], replacements[], taintedsubject55)
string(33) ">9<( )>8<( )>7<( )>6<( )>5<( )>4<" refcount(2) taint(0x55)
==== preg_replace(patterns[], taintedreplacements11_22[], subject)
string(33) ">9<( )>8<( )>7<( )>6<( )>5<( )>4<" refcount(2) taint(0x33)
==== preg_replace(pattern/e, '>subject<', subject)
string(83) ">9 8 7 6 5 4< >9 8 7 6 5 4< >9 8 7 6 5 4< >9 8 7 6 5 4< >9 8 7 6 5 4< >9 8 7 6 5 4<" refcount(2)
==== preg_replace(pattern/e, '>subject<', taintedsubject55)
Warning: preg_replace(): Modifier /e: subject text contains data that is not marked safe for internal control (TC_SELF) in ext/taint/tests/preg_replace.php on line 95
string(83) ">9 8 7 6 5 4< >9 8 7 6 5 4< >9 8 7 6 5 4< >9 8 7 6 5 4< >9 8 7 6 5 4< >9 8 7 6 5 4<" refcount(2) taint(0x55)
==== preg_replace(pattern/e, '>taintedsubject55<', subject)
string(83) ">9 8 7 6 5 4< >9 8 7 6 5 4< >9 8 7 6 5 4< >9 8 7 6 5 4< >9 8 7 6 5 4< >9 8 7 6 5 4<" refcount(2) taint(0x55)
==== preg_replace(pattern/e, >taintedsubject55<, subject)
Warning: preg_replace(): Modifier /e: replacement text contains data that is not marked safe for internal control (TC_SELF) in ext/taint/tests/preg_replace.php on line 103
string(83) ">9 8 7 6 5 4< >9 8 7 6 5 4< >9 8 7 6 5 4< >9 8 7 6 5 4< >9 8 7 6 5 4< >9 8 7 6 5 4<" refcount(2) taint(0x55)
==== preg_replace_callback(pattern, create_function, subject)
string(23) "9#9 8#8 7#7 6#6 5#5 4#4" refcount(2)
==== preg_replace_callback(pattern, callback, subject)
string(23) "9#9 8#8 7#7 6#6 5#5 4#4" refcount(2)
==== preg_replace_callback(pattern, callback, taintedsubject55)
string(23) "9#9 8#8 7#7 6#6 5#5 4#4" refcount(2) taint(0x55)
==== preg_replace_callback(pattern, tainted_callback, subject)
Warning: preg_replace_callback(): Replacement callback name contains data that is not marked safe for internal control (TC_SELF) in ext/taint/tests/preg_replace.php on line 124
string(23) "9#9 8#8 7#7 6#6 5#5 4#4" refcount(2) taint(0xff)
