--TEST--
TAINT preg_split
--SKIPIF--
<?php if (!extension_loaded('pcre')) die('skip no pcre support'); ?>
<?php if (!extension_loaded('taint')) die('skip no taint support'); ?>
--FILE--
<?php
# Workaround to avoid absolute script pathnames in error messages.
include "taint_tests_error_handler.php";

echo "==== pattern and tainted_pattern\n";
$tainted_pattern = $pattern = "/(\s+)/";
taint($tainted_pattern, TC_ALL);
debug_zval_dump($pattern);
debug_zval_dump($tainted_pattern);

echo "==== subject and tainted_subject55\n";
$tainted_subject55 = $subject = "9 8 7 6 5 4";
taint($tainted_subject55,0x55);
debug_zval_dump($subject);
debug_zval_dump($tainted_subject55);

echo "==== limit and tainted_limit\n";
$tainted_limit = $limit = "-1";
taint($tainted_limit, TC_ALL);
debug_zval_dump($limit);
debug_zval_dump($tainted_limit);

echo "==== delim_capture and tainted_delim_capture\n";
$tainted_delim_capture = $delim_capture = PREG_SPLIT_DELIM_CAPTURE;
taint($tainted_delim_capture, TC_ALL);
debug_zval_dump($delim_capture);
debug_zval_dump($tainted_delim_capture);

echo "==== offset_capture and tainted_offset_capture\n";
$tainted_offset_capture = $offset_capture = PREG_SPLIT_OFFSET_CAPTURE;
taint($tainted_offset_capture, TC_ALL);
debug_zval_dump($offset_capture);
debug_zval_dump($tainted_offset_capture);

echo "==== preg_split(pattern, subject)\n";
$result = preg_split($pattern, $subject);
debug_zval_dump($result);

echo "==== preg_split(tainted_pattern, subject)\n";
$result = preg_split($tainted_pattern, $subject);
debug_zval_dump($result);

echo "==== preg_split(pattern, tainted_subject55)\n";
$result = preg_split($pattern, $tainted_subject55);
debug_zval_dump($result);

echo "==== preg_split(pattern, subject, limit)\n";
$result = preg_split($pattern, $subject, $limit);
debug_zval_dump($result);

echo "==== preg_split(pattern, subject, tainted_limit)\n";
$result = preg_split($pattern, $subject, $tainted_limit);
debug_zval_dump($result);

echo "==== preg_split(pattern, subject, limit, offset_capture)\n";
$result = preg_split($pattern, $subject, $limit, $offset_capture);
debug_zval_dump($result);

echo "==== preg_split(pattern, subject, limit, tainted_offset_capture)\n";
$result = preg_split($pattern, $subject, $limit, $tainted_offset_capture);
debug_zval_dump($result);

echo "==== preg_split(pattern, subject, limit, offset_capture | delim_capture)\n";
$result = preg_split($pattern, $subject, $limit, $offset_capture | $delim_capture);
debug_zval_dump($result);

?>
--EXPECT--
==== pattern and tainted_pattern
string(7) "/(\s+)/" refcount(2)
string(7) "/(\s+)/" refcount(2) taint(0xff)
==== subject and tainted_subject55
string(11) "9 8 7 6 5 4" refcount(2)
string(11) "9 8 7 6 5 4" refcount(2) taint(0x55)
==== limit and tainted_limit
string(2) "-1" refcount(2)
string(2) "-1" refcount(2) taint(0xff)
==== delim_capture and tainted_delim_capture
long(2) refcount(2)
long(2) refcount(2) taint(0xff)
==== offset_capture and tainted_offset_capture
long(4) refcount(2)
long(4) refcount(2) taint(0xff)
==== preg_split(pattern, subject)
array(6) refcount(2){
  [0]=>
  string(1) "9" refcount(1)
  [1]=>
  string(1) "8" refcount(1)
  [2]=>
  string(1) "7" refcount(1)
  [3]=>
  string(1) "6" refcount(1)
  [4]=>
  string(1) "5" refcount(1)
  [5]=>
  string(1) "4" refcount(1)
}
==== preg_split(tainted_pattern, subject)
Warning: preg_split(): Argument 1 contains data that is not converted with preg_quote() in ext/taint/tests/preg_split.php on line 40
array(6) refcount(2){
  [0]=>
  string(1) "9" refcount(1)
  [1]=>
  string(1) "8" refcount(1)
  [2]=>
  string(1) "7" refcount(1)
  [3]=>
  string(1) "6" refcount(1)
  [4]=>
  string(1) "5" refcount(1)
  [5]=>
  string(1) "4" refcount(1)
}
==== preg_split(pattern, tainted_subject55)
array(6) refcount(2){
  [0]=>
  string(1) "9" refcount(1) taint(0x55)
  [1]=>
  string(1) "8" refcount(1) taint(0x55)
  [2]=>
  string(1) "7" refcount(1) taint(0x55)
  [3]=>
  string(1) "6" refcount(1) taint(0x55)
  [4]=>
  string(1) "5" refcount(1) taint(0x55)
  [5]=>
  string(1) "4" refcount(1) taint(0x55)
}
==== preg_split(pattern, subject, limit)
array(6) refcount(2){
  [0]=>
  string(1) "9" refcount(1)
  [1]=>
  string(1) "8" refcount(1)
  [2]=>
  string(1) "7" refcount(1)
  [3]=>
  string(1) "6" refcount(1)
  [4]=>
  string(1) "5" refcount(1)
  [5]=>
  string(1) "4" refcount(1)
}
==== preg_split(pattern, subject, tainted_limit)
Warning: preg_split(): Argument 3 contains data that is not marked safe for internal control (TC_SELF) in ext/taint/tests/preg_split.php on line 52
array(6) refcount(2){
  [0]=>
  string(1) "9" refcount(1)
  [1]=>
  string(1) "8" refcount(1)
  [2]=>
  string(1) "7" refcount(1)
  [3]=>
  string(1) "6" refcount(1)
  [4]=>
  string(1) "5" refcount(1)
  [5]=>
  string(1) "4" refcount(1)
}
==== preg_split(pattern, subject, limit, offset_capture)
array(6) refcount(2){
  [0]=>
  array(2) refcount(1){
    [0]=>
    string(1) "9" refcount(1)
    [1]=>
    long(0) refcount(1)
  }
  [1]=>
  array(2) refcount(1){
    [0]=>
    string(1) "8" refcount(1)
    [1]=>
    long(2) refcount(1)
  }
  [2]=>
  array(2) refcount(1){
    [0]=>
    string(1) "7" refcount(1)
    [1]=>
    long(4) refcount(1)
  }
  [3]=>
  array(2) refcount(1){
    [0]=>
    string(1) "6" refcount(1)
    [1]=>
    long(6) refcount(1)
  }
  [4]=>
  array(2) refcount(1){
    [0]=>
    string(1) "5" refcount(1)
    [1]=>
    long(8) refcount(1)
  }
  [5]=>
  array(2) refcount(1){
    [0]=>
    string(1) "4" refcount(1)
    [1]=>
    long(10) refcount(1)
  }
}
==== preg_split(pattern, subject, limit, tainted_offset_capture)
Warning: preg_split(): Argument 4 contains data that is not marked safe for internal control (TC_SELF) in ext/taint/tests/preg_split.php on line 60
array(6) refcount(2){
  [0]=>
  array(2) refcount(1){
    [0]=>
    string(1) "9" refcount(1)
    [1]=>
    long(0) refcount(1)
  }
  [1]=>
  array(2) refcount(1){
    [0]=>
    string(1) "8" refcount(1)
    [1]=>
    long(2) refcount(1)
  }
  [2]=>
  array(2) refcount(1){
    [0]=>
    string(1) "7" refcount(1)
    [1]=>
    long(4) refcount(1)
  }
  [3]=>
  array(2) refcount(1){
    [0]=>
    string(1) "6" refcount(1)
    [1]=>
    long(6) refcount(1)
  }
  [4]=>
  array(2) refcount(1){
    [0]=>
    string(1) "5" refcount(1)
    [1]=>
    long(8) refcount(1)
  }
  [5]=>
  array(2) refcount(1){
    [0]=>
    string(1) "4" refcount(1)
    [1]=>
    long(10) refcount(1)
  }
}
==== preg_split(pattern, subject, limit, offset_capture | delim_capture)
array(11) refcount(2){
  [0]=>
  array(2) refcount(1){
    [0]=>
    string(1) "9" refcount(1)
    [1]=>
    long(0) refcount(1)
  }
  [1]=>
  array(2) refcount(1){
    [0]=>
    string(1) " " refcount(1)
    [1]=>
    long(1) refcount(1)
  }
  [2]=>
  array(2) refcount(1){
    [0]=>
    string(1) "8" refcount(1)
    [1]=>
    long(2) refcount(1)
  }
  [3]=>
  array(2) refcount(1){
    [0]=>
    string(1) " " refcount(1)
    [1]=>
    long(3) refcount(1)
  }
  [4]=>
  array(2) refcount(1){
    [0]=>
    string(1) "7" refcount(1)
    [1]=>
    long(4) refcount(1)
  }
  [5]=>
  array(2) refcount(1){
    [0]=>
    string(1) " " refcount(1)
    [1]=>
    long(5) refcount(1)
  }
  [6]=>
  array(2) refcount(1){
    [0]=>
    string(1) "6" refcount(1)
    [1]=>
    long(6) refcount(1)
  }
  [7]=>
  array(2) refcount(1){
    [0]=>
    string(1) " " refcount(1)
    [1]=>
    long(7) refcount(1)
  }
  [8]=>
  array(2) refcount(1){
    [0]=>
    string(1) "5" refcount(1)
    [1]=>
    long(8) refcount(1)
  }
  [9]=>
  array(2) refcount(1){
    [0]=>
    string(1) " " refcount(1)
    [1]=>
    long(9) refcount(1)
  }
  [10]=>
  array(2) refcount(1){
    [0]=>
    string(1) "4" refcount(1)
    [1]=>
    long(10) refcount(1)
  }
}
