--TEST--
TAINT shell command escape test
--SKIPIF--
<?php if (!extension_loaded('taint')) die('skip no taint support'); ?>
--INI--
taint_marks_other = TC_NONE
--FILE--
<?php
# Workaround to avoid absolute script pathnames in error messages.
include "taint_tests_error_handler.php";

# Untainted data test.

echo "======= 1: expect taint 0x0\n";
$x = "123";
debug_zval_dump($x);
system("echo $x");

# Tainted data test.

echo "======= 2: expect taint 0xff\n";
taint($x, 0xff);
debug_zval_dump($x);
system("echo $x");

# Sanitizer test.

echo "======= 3: escapeshellarg: expect taint 0xfe\n";
$y = $x;
$y = escapeshellarg($y);
debug_zval_dump($y);
system("echo $y");

echo "======= 4: escapeshellcmd: expect taint 0xfe\n";
$y = $x;
$y = escapeshellcmd($y);
debug_zval_dump($y);
system("echo $y");

?>
--EXPECT--
======= 1: expect taint 0x0
string(3) "123" refcount(2)
123
======= 2: expect taint 0xff
string(3) "123" refcount(2) taint(0xff)
Warning: system(): Argument 1 contains data that is not converted with escapeshellarg() or escapeshellcmd() in ext/taint/tests/shell-escape.php on line 17
123
======= 3: escapeshellarg: expect taint 0xfe
string(5) "'123'" refcount(2) taint(0xfb)
123
======= 4: escapeshellcmd: expect taint 0xfe
string(3) "123" refcount(2) taint(0xfb)
123
