--TEST--
TAINT sscanf conversion test (array result)
--SKIPIF--
<?php if (!extension_loaded('taint')) die('skip no taint support'); ?>
--INI--
--FILE--
<?php

# Untainted data test.

echo "====\n1: expect taint 0x0\n";
$x = "123";
debug_zval_dump($x);

# Tainted data test.

echo "====\n2: expect taint 0x55\n";
$y = "456";
taint($y, 0x55);
debug_zval_dump($y);

# Taint is copied verbatim from source string to result string.

echo "====\n3: expect taint 0x55\n";
$n = sscanf("$x $y", "%s %s");
debug_zval_dump($n);

# No taint is copied when result is clean.

echo "====\n4: expect taint 0x0\n";
$n = sscanf("$x", "%c%c");
debug_zval_dump($n);

# Taint is copied verbatim from source string to result string.

echo "====\n5: expect taint 0x55\n";
$n = sscanf("$y", "%c%c");
debug_zval_dump($n);

# Taint is copied verbatim from source string to result string.

echo "====\n6: expect taint 0x55\n";
$n = sscanf("$x $y", "%[^ ] %[^ ]");
debug_zval_dump($n);

# Taint subset is copied from source string to result number.

echo "====\n7: expect taint ", ini_get("taint_marks_non_string"), "\n";
$c = sscanf("$x $y", "%d %d");
debug_zval_dump($c);

# Taint subset is copied from source string to result number.

echo "====\n8: expect taint ", ini_get("taint_marks_non_string"), "\n";
$c = sscanf("$x $y", "%g %g");
debug_zval_dump($c);

?>
--EXPECT--
====
1: expect taint 0x0
string(3) "123" refcount(2)
====
2: expect taint 0x55
string(3) "456" refcount(2) taint(0x55)
====
3: expect taint 0x55
array(2) refcount(2){
  [0]=>
  string(3) "123" refcount(1) taint(0x55)
  [1]=>
  string(3) "456" refcount(1) taint(0x55)
}
====
4: expect taint 0x0
array(2) refcount(2){
  [0]=>
  string(1) "1" refcount(1)
  [1]=>
  string(1) "2" refcount(1)
}
====
5: expect taint 0x55
array(2) refcount(2){
  [0]=>
  string(1) "4" refcount(1) taint(0x55)
  [1]=>
  string(1) "5" refcount(1) taint(0x55)
}
====
6: expect taint 0x55
array(2) refcount(2){
  [0]=>
  string(3) "123" refcount(1) taint(0x55)
  [1]=>
  string(3) "456" refcount(1) taint(0x55)
}
====
7: expect taint TC_SELF
array(2) refcount(2){
  [0]=>
  long(123) refcount(1) taint(0x1)
  [1]=>
  long(456) refcount(1) taint(0x1)
}
====
8: expect taint TC_SELF
array(2) refcount(2){
  [0]=>
  double(123) refcount(1) taint(0x1)
  [1]=>
  double(456) refcount(1) taint(0x1)
}
