--TEST--
TAINT string/boolean conversion test
--SKIPIF--
<?php if (!extension_loaded('taint')) die('skip no taint support'); ?>
--INI--
--FILE--
<?php
# Workaround to avoid absolute script pathnames in error messages.
include "taint_tests_error_handler.php";

# Untainted data test.

$x = "123";
echo "1: expect taint 0x0\n";
debug_zval_dump($x);
echo "$x\n";

# Tainted data test.

taint($x, 0x55);
echo "2: expect taint 0x55\n";
debug_zval_dump($x);
echo "$x\n";

# Taint propagates from argument to result.

$y = sprintf("%s", $x);
echo "3: expect taint 0x55\n";
debug_zval_dump($y);
echo "$y\n";

# Taint subset propagates after conversion to bool.

$y = sprintf("%s", (bool) $x);
echo "4: expect taint ", ini_get("taint_marks_non_string"), "\n";
debug_zval_dump($y);
echo "$y\n";

# Taint subset propagates after conversion to bool.

$x = (bool) $x;
echo "5: expect taint ", ini_get("taint_marks_non_string"), "\n";
debug_zval_dump($x);
echo "$x\n";

?>
--EXPECT--
1: expect taint 0x0
string(3) "123" refcount(2)
123
2: expect taint 0x55
string(3) "123" refcount(2) taint(0x55)
123
3: expect taint 0x55
string(3) "123" refcount(2) taint(0x55)
123
4: expect taint TC_SELF
string(1) "1" refcount(2) taint(0x1)
1
5: expect taint TC_SELF
bool(true) refcount(2) taint(0x1)
1
