--TEST--
TAINT run container policies when altering directories
--SKIPIF--
<?php if (!extension_loaded('taint')) die('skip no taint support'); ?>
--FILE--
<?php
require_once ("taint/taint.php");

class DefaultDirPolicy extends DummyPolicy {
  public function __toString () { return "DefaultDirPolicy"; }
  public function __output ($type, $dst) { return; }
}

class MyDirPolicy extends DefaultDirPolicy {
  public function __toString () { return "MyDirPolicy"; }
  public function __output ($type, $dst) { 
    echo "MyDirPolicy::__output($type, $dst[0], $dst[1])\n"; 
    switch ($type) {
    case 'create':
    case 'open':
    case 'mkdir':
    case 'rmdir':
    case 'unlink':
      return;
    default:
      throw new Exception("Unexpected action: ($type, $dst[0], $dst[1])");
    }
  }
}

$dirname = '/tmp/php-test';
$testfile = 'testfile';
$testdir = 'testdir';
$p = new MyDirPolicy ();

mkdir ($dirname);

echo "opening directory\n";
$d = fopen ($dirname, 'r');

taint_set_file_policy($d, $p);

echo "creating file in dir\n";
$f = fopen ($dirname . '/' . $testfile, 'w');
fclose ($f);

echo "making dir\n";
mkdir ($dirname . '/' . $testdir);

echo "reading dir\n";
$r = opendir ($dirname);
$files = array ();
while (($file = readdir($r)) !== false)
  $files[] = $file;
closedir($r);
sort($files);
print_r ($files);


echo "removing dir\n";
rmdir ($dirname . '/' . $testdir);

echo "removing file\n";
unlink ($dirname . '/' . $testfile);

$p = NULL;
taint_set_file_policy($d, $p);

rmdir ($dirname);

?>
--EXPECT--
opening directory
creating file in dir
MyDirPolicy::__output(create, /tmp/php-test, /tmp/php-test/testfile)
making dir
MyDirPolicy::__output(mkdir, /tmp/php-test, /tmp/php-test/testdir)
reading dir
MyDirPolicy::__output(open, /tmp/php-test, r)
Array
(
    [0] => .
    [1] => ..
    [2] => testdir
    [3] => testfile
)
removing dir
MyDirPolicy::__output(rmdir, /tmp/php-test, /tmp/php-test/testdir)
removing file
MyDirPolicy::__output(unlink, /tmp/php-test, /tmp/php-test/testfile)
