--TEST--
TAINT container policies on files
--SKIPIF--
<?php if (!extension_loaded('taint')) die('skip no taint support'); ?>
--FILE--
<?php

class FilePolicy
{
	public $s;
	public function __construct($name) { $this->s = $name; }
	public function __output($type, $mode) {
		echo "output check [", $this->s, "]: $type, $mode\n";
	}
}

$p1 = new FilePolicy("p1");
$p2 = new FilePolicy("p2");

$f1 = fopen("/tmp/test-file-1.txt", "w");
fwrite($f1, "test 1\n");
taint_set_file_policy($f1, $p1);
fclose($f1);

$f2 = fopen("/tmp/test-file-2.txt", "w");
fwrite($f2, "test 2\n");
taint_set_file_policy($f2, $p2);
fclose($f2);

$fx = fopen("/tmp/test-file-1.txt", "r");
fclose($fx);

$fx = fopen("/tmp/test-file-2.txt", "a");
fclose($fx);

unlink("/tmp/test-file-1.txt");
unlink("/tmp/test-file-2.txt");

echo "done.\n";

?>
--EXPECT--
output check [p1]: open, r
output check [p2]: open, a
done.
