--TEST--
TAINT track policies in files via put_contents, get_contents -- requires user_xattr mount flag
--SKIPIF--
<?php if (!extension_loaded('taint')) die('skip no taint support'); ?>
--FILE--
<?php
require_once ("taint/taint.php");
$a = "Hello world!\n";
taint_set_policy ($a, new DummyPolicy("Policy foobar"));

$x = taint_get_policy ($a);
echo "Initial string:      "; echo $a;
echo "Policy:              "; echo mp_to_str($x); echo "\n";

echo "Serialized policy:   ";
echo serialize($x);
echo "\n";

$y = unserialize(serialize($x));
echo "Deserialized policy: ";
echo mp_to_str ($y);
echo "\n";

file_put_contents("/tmp/test-file.txt", $a);
rename("/tmp/test-file.txt", "/tmp/test-file-2.txt") or die("cannot rename");
$b = file_get_contents("/tmp/test-file-2.txt");
unlink("/tmp/test-file-2.txt") or die("cannot unlink");

echo "Reading from file:   ";
echo $b;

echo "Policy:              ";
echo mp_to_str (taint_get_policy($b));
echo "\n";

?>
--EXPECT--
Initial string:      Hello world!
Policy:              inf@0: Policy foobar
Serialized policy:   a:1:{i:0;a:3:{s:6:"offset";i:0;s:6:"nbytes";i:999999999;s:6:"policy";O:11:"DummyPolicy":1:{s:1:"s";s:13:"Policy foobar";}}}
Deserialized policy: inf@0: Policy foobar
Reading from file:   Hello world!
Policy:              inf@0: Policy foobar
