--TEST--
TAINT track policies in files via fwrite, fgets -- requires user_xattr mount flag
--SKIPIF--
<?php if (!extension_loaded('taint')) die('skip no taint support'); ?>
--FILE--
<?php
require_once ("taint/taint.php");
class Policy
{
  public $s;
  public function __construct($name) { $this->s = $name; }
  public function __toString()       { return "Policy " . $this->s; }
  public function __output()         {}
}

$a = "Hello world!\n";
taint_set_policy ($a, new Policy("foobar"));

$x = taint_get_policy ($a);
echo "Initial string:      "; echo $a;
echo "Policy:              "; echo mp_to_str($x); echo "\n";

echo "Serialized policy:   ";
echo serialize($x);
echo "\n";

$y = unserialize(serialize($x));
echo "Deserialized policy: ";
echo mp_to_str($y);
echo "\n";

$f = fopen("/tmp/test-file.txt", "w") or die("cannot open file\n");
fwrite($f, $a);
fclose($f);

rename("/tmp/test-file.txt", "/tmp/test-file-2.txt");

$g = fopen("/tmp/test-file-2.txt", "r") or die("cannot open file\n");
$b = fgets($g);
fclose($g);

unlink("/tmp/test-file-2.txt");

echo "Reading from file:   ";
echo $b;

echo "Policy:              ";
echo mp_to_str(taint_get_policy($b));
echo "\n";

?>
--EXPECT--
Initial string:      Hello world!
Policy:              inf@0: Policy foobar
Serialized policy:   a:1:{i:0;a:3:{s:6:"offset";i:0;s:6:"nbytes";i:999999999;s:6:"policy";O:6:"Policy":1:{s:1:"s";s:6:"foobar";}}}
Deserialized policy: inf@0: Policy foobar
Reading from file:   Hello world!
Policy:              inf@0: Policy foobar
