--TEST--
TAINT invoke policy object on writing data to output
--SKIPIF--
<?php if (!extension_loaded('taint')) die('skip no taint support'); ?>
--FILE--
<?php
require_once ("taint/taint.php");

class Policy {
    private $s;
    public function __construct($name) { $this->s = $name; }
    public function __toString() { return "Policy " . $this->s; }
    public function __output() { echo "[policy ", $this->s, "] "; }
}

class BlockingPolicy {
    public function __output($type, $obj) { throw new Exception("blocking output to ". $type. " ". $obj); }
}

$a = "Hello ";
$b = "world!";
taint_set_policy($a, new Policy("a"));
taint_set_policy($b, new Policy("b"));

try {
    echo "a: ", $a, "\n";
} catch (Exception $e) {
    echo "*** Exception: ", $e, "\n";
}

try {
    $c = $a . $b;
    echo "Merged string: ", $c, "\n";
    echo "Merged policy: ", mp_to_str(taint_get_policy($c)), "\n";
} catch (Exception $e) {
    echo "*** Exception: ", $e, "\n";
}

$d = "secret";
taint_set_policy($d, new BlockingPolicy());
try {
    print $d;
} catch (Exception $e) {
    echo "*** Exception: ", $e->getMessage(), "\n";
}

try {
    mail("nickolai@csail.mit.edu", "hello", $d);
} catch (Exception $e) {
    echo "*** Exception: ", $e->getMessage(), "\n";
}

echo "All done!\n";
?>
--EXPECT--
a: [policy a] Hello 
Merged string: [policy a] [policy b] Hello world!
Merged policy: 6@0: Policy a, 6@6: Policy b
*** Exception: blocking output to print 1
*** Exception: blocking output to mail nickolai@csail.mit.edu
All done!
