--TEST--
TAINT byte-level policy tracking
--SKIPIF--
<?php if (!extension_loaded('taint')) die('skip no taint support'); ?>
--FILE--
<?php

require_once('taint/taint.php');

$pa = new DummyPolicy("p1");
$a = "Hello";
taint_set_policy($a, $pa);

$pb = new DummyPolicy("p2");
$b = "world";
taint_set_policy($b, $pb);

$x = 123;
taint_set_policy($x, new DummyPolicy("p4"));

$dash = '--';
taint_set_policy($dash, new DummyPolicy("p3"));
$fmt = $dash . '%s %s %04d %d' . $dash;

$fmt2 = '<%s %s>';
taint_set_policy($fmt2, new DummyPolicy("p3"));

echo $a, ": ", mp_to_str(taint_get_policy($a)), "\n";
echo $b, ": ", mp_to_str(taint_get_policy($b)), "\n";

$c = "<$a $b>";
echo $c, ": ", mp_to_str(taint_get_policy($c)), "\n";

$d = substr($c, 1, 4);
echo $d, ": ", mp_to_str(taint_get_policy($d)), "\n";

$e = substr($c, 8, 2);
echo $e, ": ", mp_to_str(taint_get_policy($e)), "\n";

$f = substr($c, 5, 5);
echo $f, ": ", mp_to_str(taint_get_policy($f)), "\n";

$g = $c[8];
echo $g, ": ", mp_to_str(taint_get_policy($g)), "\n";

$c[3] = $c[10];
echo $c, ": ", mp_to_str(taint_get_policy($c)), "\n";

echo $fmt, ": ", mp_to_str(taint_get_policy($fmt)), "\n";
$s = sprintf ($fmt, $a, $b, $x, $x);
echo $s, ": ", mp_to_str(taint_get_policy($s)), "\n";

// This test should merge policies from the fmt and $a and $b.
// but it currently does not.
$s = sprintf ($fmt2, $a, $b);
echo $s, ": ", mp_to_str(taint_get_policy($s)), "\n";

$s = implode (',', array ($a, $b));
echo $s, ": ", mp_to_str(taint_get_policy($s)), "\n";

$s = implode ($dash, array ($a, $b));
echo $s, ": ", mp_to_str(taint_get_policy($s)), "\n";

$s = implode (", ", array ("x=$a", "x=$b"));
echo $s, ": ", mp_to_str(taint_get_policy($s)), "\n";

$s = sprintf ("%s", $s);
echo $s, ": ", mp_to_str(taint_get_policy($s)), "\n";

?>
--EXPECT--
Hello: inf@0: p1
world: inf@0: p2
<Hello world>: 5@1: p1, 5@7: p2
Hell: 4@0: p1
or: 2@0: p2
o wor: 1@0: p1, 3@2: p2
o: 1@0: p2
<Hello world>: 2@1: p1, 1@3: p2, 2@4: p1, 5@7: p2
--%s %s %04d %d--: 2@0: p3, 2@15: p3
--Hello world 0123 123--: 2@0: p3, 5@2: p1, 5@8: p2, 4@14: p4, 3@19: p4, 2@22: p3
<Hello world>: 1@0: p3, 5@1: p1, 1@6: p3, 5@7: p2, 1@12: p3
Hello,world: 5@0: p1, 5@6: p2
Hello--world: 5@0: p1, 2@5: p3, 5@7: p2
x=Hello, x=world: 5@2: p1, 5@11: p2
x=Hello, x=world: 5@2: p1, 5@11: p2
