--TEST--
TAINT eval policy
--SKIPIF--
<?php if (!extension_loaded('taint')) die('skip no taint support'); ?>
--FILE--
<?php

require_once("taint/taint.php");

class CodePolicy
{
	public function __toString() { return "CodePolicy"; }
	public function __output() {}
}

function __policy_eval($mp) {
	# taint.php not fully included yet
	if (!function_exists("__policy_has_annotation"))
		return;

	echo "__policy_eval\n";

	if (!__policy_has_annotation($mp, "CodePolicy"))
		throw new Exception("code injection!");
}

$s0 = "echo \"5\\n\";\n";
$s = $s0;
taint_set_policy($s, new CodePolicy());

echo "Code snippet:\n";
echo $s;

echo "Trying eval..\n";
eval($s);

echo "Trying require..\n";
file_put_contents("/tmp/x.php", "<?php\n". $s. "?>\n");
require("/tmp/x.php");

$t = $s0;
echo "Trying eval on bare string..\n";
try {
	eval($t);
} catch (Exception $e) {
	echo "Exception: ", $e->getMessage(), "\n";
}

?>
--EXPECT--
Code snippet:
echo "5\n";
Trying eval..
__policy_eval
5
Trying require..
__policy_eval
5
Trying eval on bare string..
__policy_eval
Exception: code injection!
