--TEST--
TAINT serialize policies along with native variables
--SKIPIF--
<?php if (!extension_loaded('taint')) die('skip no taint support'); ?>
--FILE--
<?php

require_once('taint/taint.php');

function test_serialize ($v1, $p1) {
  if ($v1)
    taint_set_policy ($v1, $p1);

  $_p1 = mp_to_str(taint_get_policy($v1));
  echo "v1: [$v1] p1: [$_p1]\n";

  $s = serialize ($v1);
  //echo "serialized: $s\n";
  $v2 = unserialize ($s);

  $p2 = null;
  if ($v1) {
    $p2 = mp_to_str(taint_get_policy($v2));

    echo "v2: [$v2] p2: [$p2]\n";
    if ($_p1 != $p2) {
      echo "expected [" . $_p1 . "]\n";
      echo "got [" . $p2 . "]\n";
      return;
    }
  } else {
    echo "v2: [$v2] p2: [$p2]\n";
  }
}

$p = new DummyPolicy("p1");

test_serialize (null, null);
test_serialize (true, null);
test_serialize (123, null);
test_serialize (1.23, null);
test_serialize ("abc", null);

test_serialize (true, $p);
test_serialize (123, $p);
test_serialize (1.23, $p);
test_serialize ("abc", $p);
?>
--EXPECT--
v1: [] p1: []
v2: [] p2: []
v1: [1] p1: []
v2: [1] p2: []
v1: [123] p1: []
v2: [123] p2: []
v1: [1.23] p1: []
v2: [1.23] p2: []
v1: [abc] p1: []
v2: [abc] p2: []
v1: [1] p1: [inf@0: p1]
v2: [1] p2: [inf@0: p1]
v1: [123] p1: [inf@0: p1]
v2: [123] p2: [inf@0: p1]
v1: [1.23] p1: [inf@0: p1]
v2: [1.23] p2: [inf@0: p1]
v1: [abc] p1: [inf@0: p1]
v2: [abc] p2: [inf@0: p1]
