--TEST--
TAINT socket policy tracking
--SKIPIF--
<?php if (!extension_loaded('taint')) die('skip no taint support'); ?>
--FILE--
<?php

require_once('taint/taint.php');

$sock = fsockopen('mit.edu', 80);
fputs($sock, "GET / HTTP/1.0\r\n\r\n");
$s = fgets($sock);
fclose($sock);
$mp1 = taint_get_policy($s);
assert(count($mp1) == 1);
assert($mp1[0]['policy'] instanceof XSPolicy);

$postfix = "postfix";
$s .= $postfix;
$mp2 = taint_get_policy($s);
assert(count($mp2) == 1);
assert($mp2[0]['policy'] instanceof XSPolicy);

try {
  echo $s;
} catch (Exception $e) {
  perr("caught1 " . $e->getMessage() . "\n");
}

$s = htmlspecialchars($s);
$p3 = taint_get_policy($s);
assert($p3 == null || count($p3->ents) == 0);

?>
--EXPECT--
caught1 XS attack!
