--TEST--
TAINT byte-level policy combined with SQL parser  
--SKIPIF--
<?php if (!extension_loaded('taint')) die('skip no taint support'); ?>
--FILE--
<?php

require_once('taint/taint.php');

function test_query ($q, $print_tree=false) {
  echo $q, ": ", mp_to_str(taint_get_policy($q)), "\n";
  print sql_translate ($q, $print_tree) . "\n";
}

$v1 = "secret1";
$v2 = "secret2";
$v3 = 123;
taint_set_policy($v1, new DummyPolicy("p1"));
taint_set_policy($v2, new DummyPolicy("p2"));
taint_set_policy($v3, new DummyPolicy("p3"));

test_query ("INSERT INTO foo (val) VALUES ('$v1')");
test_query ("INSERT INTO t1 (c1, c2) VALUES ('hello', '$v1')");
test_query ("INSERT INTO foo (c1, c2) SELECT x, y FROM bar");
test_query ("INSERT INTO t1 (c1) VALUES ('$v1')");
test_query ("INSERT INTO t1 (c1) VALUES ('$v1' + 1)");
test_query ("INSERT INTO t1 (c1) VALUES ('$v1' + '$v2')");

test_query ("UPDATE t1 SET c1='$v1' WHERE c2=123");
test_query ("UPDATE t1 SET c1=$v3 WHERE c2=123");

?>
--EXPECT--
INSERT INTO foo (val) VALUES ('secret1'): 7@31: p1
INSERT INTO foo (val, val_policy) VALUES ('secret1', 'a:1:{i:0;a:3:{s:6:\"offset\";i:0;s:6:\"nbytes\";i:999999999;s:6:\"policy\";O:11:\"DummyPolicy\":1:{s:1:\"s\";s:2:\"p1\";}}}')
INSERT INTO t1 (c1, c2) VALUES ('hello', 'secret1'): 7@42: p1
INSERT INTO t1 (c1, c2, c1_policy, c2_policy) VALUES ('hello', 'secret1', NULL, 'a:1:{i:0;a:3:{s:6:\"offset\";i:0;s:6:\"nbytes\";i:999999999;s:6:\"policy\";O:11:\"DummyPolicy\":1:{s:1:\"s\";s:2:\"p1\";}}}')
INSERT INTO foo (c1, c2) SELECT x, y FROM bar: 
INSERT INTO foo (c1, c2, c1_policy, c2_policy) SELECT x, y, x_policy, y_policy FROM bar
INSERT INTO t1 (c1) VALUES ('secret1'): 7@29: p1
INSERT INTO t1 (c1, c1_policy) VALUES ('secret1', 'a:1:{i:0;a:3:{s:6:\"offset\";i:0;s:6:\"nbytes\";i:999999999;s:6:\"policy\";O:11:\"DummyPolicy\":1:{s:1:\"s\";s:2:\"p1\";}}}')
INSERT INTO t1 (c1) VALUES ('secret1' + 1): 7@29: p1
INSERT INTO t1 (c1, c1_policy) VALUES (('secret1' + 1), 'a:1:{i:0;a:3:{s:6:\"offset\";i:0;s:6:\"nbytes\";i:999999999;s:6:\"policy\";O:11:\"DummyPolicy\":1:{s:1:\"s\";s:2:\"p1\";}}}')
INSERT INTO t1 (c1) VALUES ('secret1' + 'secret2'): 7@29: p1, 7@41: p2
INSERT INTO t1 (c1, c1_policy) VALUES (('secret1' + 'secret2'), 'a:2:{i:0;a:3:{s:6:\"offset\";i:0;s:6:\"nbytes\";i:999999999;s:6:\"policy\";O:11:\"DummyPolicy\":1:{s:1:\"s\";s:2:\"p1\";}}i:1;a:3:{s:6:\"offset\";i:0;s:6:\"nbytes\";i:999999999;s:6:\"policy\";O:11:\"DummyPolicy\":1:{s:1:\"s\";s:2:\"p2\";}}}')
UPDATE t1 SET c1='secret1' WHERE c2=123: 7@18: p1
UPDATE t1 SET c1='secret1', c1_policy='a:1:{i:0;a:3:{s:6:\"offset\";i:0;s:6:\"nbytes\";i:999999999;s:6:\"policy\";O:11:\"DummyPolicy\":1:{s:1:\"s\";s:2:\"p1\";}}}' WHERE (c2 = 123)
UPDATE t1 SET c1=123 WHERE c2=123: 3@17: p3
UPDATE t1 SET c1=123, c1_policy='a:1:{i:0;a:3:{s:6:\"offset\";i:0;s:6:\"nbytes\";i:999999999;s:6:\"policy\";O:11:\"DummyPolicy\":1:{s:1:\"s\";s:2:\"p3\";}}}' WHERE (c2 = 123)
