--TEST--
TAINT translate SQL queries to add policy columns and data
--SKIPIF--
<?php if (!extension_loaded('taint')) die('skip no taint support'); ?>
--FILE--
<?php

require_once('taint/taint.php');

function test_query ($q, $print_tree=false) {
  //echo $q, ": ", taint_get_policy($q), "\n";
  echo $q . "\n";
  print sql_translate ($q, $print_tree) . "\n";
}

test_query ("SELECT col1 FROM table1;");
test_query ("SELECT col1 a1 FROM table1;");
test_query ("SELECT col1, col2 FROM table1");
test_query ("SELECT table1.col1 FROM table1;");
test_query ("SELECT x FROM t1 WHERE x=1 AND y IN (SELECT z FROM t2)");
test_query ("SELECT t1.x FROM t1 WHERE t1.x=1 AND t1.y IN (SELECT t2.z FROM t2)");
test_query ("SELECT t1.*, t2.* FROM table1 t1, table2 t2");
test_query ("select max(x), t1.c1 as c1a, max(t1.c2) as c2a, count(t2.c3) as c3a, t4.c4, 0, 0, 0 from t1 left join t2 on (t1.c1=t2.c2) left join t3 on (t3.c1=t1.c1) left join t4 as t4a on (t4.c1=t1.c1) where t1.c1=2 group by t1.c1");
test_query ("SELECT c1 FROM t1 LEFT JOIN (SELECT c2, c3 FROM t2) ON (x=y)");
test_query ("SELECT t1.*, t2.c1, t3.f1, t4.c1 FROM t1 LEFT JOIN t2 ON (a=b) LEFT JOIN (SELECT max(x,y) AS f1 FROM xx) AS t3 ON (b=c) LEFT JOIN t4 ON (c=d)");

test_query ("delete from PaperConflict where paperId=1 and conflictType>=2 and conflictType<=7");

test_query ("CREATE TEMPORARY TABLE newtable SELECT c1, c2 FROM t1 LEFT JOIN t2 ON (x=y)");
test_query ("CREATE TEMPORARY TABLE newtable SELECT t1.c1 AS a1, t2.c1 AS a2 FROM t1 LEFT JOIN t2 ON (x=y)");

test_query ("INSERT INTO t1 (x, y, z) SELECT 111, c1, max(1,2) FROM t2");

/*
test_query ("SELECT phpbb_sessions.*, phpbb_users.* FROM phpbb_sessions, phpbb_users WHERE phpbb_sessions.session_id = 'c2472ce5f5d20b574221eb8bfb11f6c7' AND phpbb_users.user_id = phpbb_sessions.session_user_id");
test_query ("SELECT s.style_id, t.template_storedb, t.template_path, t.template_id, t.bbcode_bitfield, t.template_inherits_id, t.template_inherit_path, c.theme_path, c.theme_name, c.theme_storedb, c.theme_id, i.imageset_path, i.imageset_id, i.imageset_name FROM phpbb_styles s, phpbb_styles_template t, phpbb_styles_theme c, phpbb_styles_imageset i WHERE s.style_id = 1 AND t.template_id = s.template_id AND c.theme_id = s.theme_id AND i.imageset_id = s.imageset_id");
test_query ("SELECT image_name, image_filename, image_lang, image_height, image_width FROM phpbb_styles_imageset_data WHERE imageset_id = 1 AND image_filename <> '' AND image_lang IN ('en', '')");
test_query ("SELECT foo FROM bar WHERE baz IN (SELECT quux FROM blah)");
test_query ("SELECT t.topic_id FROM phpbb_topics t WHERE t.forum_id = 2 AND t.topic_type IN (0, 1) AND t.topic_approved = 1 ORDER BY t.topic_type DESC, t.topic_last_post_time DESC LIMIT 25");
test_query ("SELECT t.*, f.* FROM (phpbb_forums f, phpbb_topics t) WHERE t.topic_id = 2 AND (f.forum_id = t.forum_id OR (t.topic_type = 3 AND f.forum_id = 2))");
test_query ("SELECT DISTINCT c.session_id FROM phpbb_confirm c LEFT JOIN phpbb_sessions s ON (c.session_id = s.session_id) WHERE s.session_id IS NULL");
test_query ("SELECT u.*, z.friend, z.foe, p.* FROM (phpbb_users u, phpbb_posts p) LEFT JOIN phpbb_zebra z ON (z.user_id = 1 AND z.zebra_id = p.poster_id) WHERE p.post_id = '1' AND u.user_id = p.poster_id");
test_query ("SELECT foo FROM bar WHERE baz NOT IN (0, 1, 2, 3, -5)");
test_query ("SELECT SQL_CALC_FOUND_ROWS p.post_id FROM (phpbb_search_wordmatch m0) LEFT JOIN phpbb_posts p ON (m0.post_id = p.post_id) WHERE m0.word_id = 62 AND p.post_approved = 1 AND p.forum_id <> 4 GROUP BY p.post_id, p.post_time ORDER BY p.post_time DESC LIMIT 250");
test_query ("SELECT FOUND_ROWS()");
test_query ("SELECT folder_id, COUNT(msg_id) as num_messages, SUM(pm_unread) as num_unread FROM phpbb_privmsgs_to WHERE user_id = 53 AND folder_id <> -3 GROUP BY folder_id");
*/

?>
--EXPECT--
SELECT col1 FROM table1;
SELECT col1, col1_policy FROM table1
SELECT col1 a1 FROM table1;
SELECT col1 AS a1, col1_policy AS a1_policy FROM table1
SELECT col1, col2 FROM table1
SELECT col1, col2, col1_policy, col2_policy FROM table1
SELECT table1.col1 FROM table1;
SELECT table1.col1, table1.col1_policy FROM table1
SELECT x FROM t1 WHERE x=1 AND y IN (SELECT z FROM t2)
SELECT x, x_policy FROM t1 WHERE ((x = 1) AND (y IN (SELECT z FROM t2)))
SELECT t1.x FROM t1 WHERE t1.x=1 AND t1.y IN (SELECT t2.z FROM t2)
SELECT t1.x, t1.x_policy FROM t1 WHERE ((t1.x = 1) AND (t1.y IN (SELECT t2.z FROM t2)))
SELECT t1.*, t2.* FROM table1 t1, table2 t2
SELECT t1.*, t2.* FROM table1 AS t1, table2 AS t2
select max(x), t1.c1 as c1a, max(t1.c2) as c2a, count(t2.c3) as c3a, t4.c4, 0, 0, 0 from t1 left join t2 on (t1.c1=t2.c2) left join t3 on (t3.c1=t1.c1) left join t4 as t4a on (t4.c1=t1.c1) where t1.c1=2 group by t1.c1
SELECT max(x), t1.c1 AS c1a, max(t1.c2) AS c2a, count(t2.c3) AS c3a, t4.c4, 0, 0, 0, t1.c1_policy AS c1a_policy, t4.c4_policy FROM t1 LEFT JOIN t2 ON (t1.c1 = t2.c2) LEFT JOIN t3 ON (t3.c1 = t1.c1) LEFT JOIN t4 AS t4a ON (t4.c1 = t1.c1) WHERE (t1.c1 = 2) GROUP BY t1.c1
SELECT c1 FROM t1 LEFT JOIN (SELECT c2, c3 FROM t2) ON (x=y)
SELECT c1, c1_policy FROM t1 LEFT JOIN (SELECT c2, c3, c2_policy, c3_policy FROM t2) ON (x = y)
SELECT t1.*, t2.c1, t3.f1, t4.c1 FROM t1 LEFT JOIN t2 ON (a=b) LEFT JOIN (SELECT max(x,y) AS f1 FROM xx) AS t3 ON (b=c) LEFT JOIN t4 ON (c=d)
SELECT t1.*, t2.c1, t3.f1, t4.c1, t2.c1_policy, t4.c1_policy FROM t1 LEFT JOIN t2 ON (a = b) LEFT JOIN (SELECT max(x, y) AS f1 FROM xx) AS t3 ON (b = c) LEFT JOIN t4 ON (c = d)
delete from PaperConflict where paperId=1 and conflictType>=2 and conflictType<=7
DELETE FROM PaperConflict WHERE (((paperId = 1) AND (conflictType >= 2)) AND (conflictType <= 7))
CREATE TEMPORARY TABLE newtable SELECT c1, c2 FROM t1 LEFT JOIN t2 ON (x=y)
CREATE TEMPORARY TABLE newtable SELECT c1, c2, c1_policy, c2_policy FROM t1 LEFT JOIN t2 ON (x = y)
CREATE TEMPORARY TABLE newtable SELECT t1.c1 AS a1, t2.c1 AS a2 FROM t1 LEFT JOIN t2 ON (x=y)
CREATE TEMPORARY TABLE newtable SELECT t1.c1 AS a1, t2.c1 AS a2, t1.c1_policy AS a1_policy, t2.c1_policy AS a2_policy FROM t1 LEFT JOIN t2 ON (x = y)
INSERT INTO t1 (x, y, z) SELECT 111, c1, max(1,2) FROM t2
INSERT INTO t1 (x, y, z, x_policy, y_policy, z_policy) SELECT 111, c1, max(1, 2), '', c1_policy, '' FROM t2
