<?php

# taint_error_handler - dump run-time stack and symbol table on error.

function taint_error_handler($errno, $errstr, $errfile, $errline, $errcontext)
{
    # Don't raise errors while printing errors...
    $saved_level = ini_get("taint_error_level");
    ini_set("taint_error_level", 0);
    PRINT "BEGIN ERROR REPORT\n";
    print "$errfile:$errline, error $errno: $errstr\n";
    print "ERROR CONTEXT\n"; print_r($errcontext);
    print "STACK TRACE\n"; debug_print_backtrace();
    PRINT "END ERROR REPORT\n";
    ini_set("taint_error_level", $saved_level);
}

# set_error_handler() won't work for E_NOTICE, E_WARNING, E_ERROR, etc.

ini_set("taint_error_level", E_USER_WARNING);
set_error_handler(taint_error_handler, E_USER_WARNING);
